#!/bin/sh

echo "Copy data from all .tmpl files inside /var/www/ into ~/.asdfTemplate"
if [ -e ~/.asdfTemplate ]; then
    echo "    ERROR: ~/.asdfTemplate already exists"
    echo -n "Press <Enter> to continue or Ctrl-C to exit..."; read
else
    for d in $(find /var/www/ -name .tmpl -printf "%h\n"); do 
        echo "'$d' => {"
        cat $d/.tmpl | grep . | sed 's,^,    ,'
        echo "},"
    done >~/.asdfTemplate
fi

echo "Creating database 'asdfTemplate'"
if [ -e ~/.asdfTemplate.db ]; then
    echo "    ERROR: ~/.asdfTemplate.db already exists"
    echo -n "Press <Enter> to continue or Ctrl-C to exit..."; read
else
    read -r -s -p "Please enter MySQL's root password: " PASS; echo
    echo "
        CREATE DATABASE IF NOT EXISTS asdfTemplate;
        GRANT ALL PRIVILEGES
            ON asdfTemplate.*
            TO asdfTemplate@localhost
            IDENTIFIED BY 'asdfTemplate';
    " | mysql -u root -p$PASS
    mysql -u asdfTemplate -pasdfTemplate asdfTemplate < asdfTemplate.sql
    echo -e "dbi:mysql:asdfTemplate\nasdfTemplate\nasdfTemplate" \
        >~/.asdfTemplate.db
    for db in $(echo 'SHOW DATABASES;' | mysql -N -u root -p$PASS); do
        if echo 'SHOW TABLES;' | mysql -N -u root -p$PASS $db |
                grep DATADICT &>/dev/null; then
            echo "    importing data from database: $db"
            echo "INSERT INTO asdfTemplate.DATADICT
                SELECT NULL, '$db', view, field, name, form, err 
                FROM DATADICT;" | mysql -u root -p$PASS $db
        fi
    done
fi

